/* TreeText ver.0.3.2
 * 
 * This software is in the public domain.
 * There are no restrictions on any sort of usage of this software.
 * 
 * $treetext: fxtreelistex.h,v 1.40.12 2001/05/16 11:22:43 Toshihiro Inoue Exp $
 */

#ifndef _FXTREELISTEX_H_
#define _FXTREELISTEX_H_

#include <fx.h>


class FXTreeListEx: public FXTreeList
{
public:
  FXDECLARE(FXTreeListEx)

public:
  enum{
    ID_LABELEDIT = FXTreeList::ID_LAST,
    ID_EDITTIMER,
    ID_LAST
  };
  
public:
  FXTreeListEx(FXComposite *p, FXint nvis, FXObject* tgt = NULL, FXSelector sel = 0, FXuint opts = 0, FXint x = 0, FXint y = 0, FXint w = 0, FXint h = 0);
  virtual ~FXTreeListEx();
  void getItemPos(FXTreeItem* item, FXint& x, FXint& y);
  FXint getDescHeight(FXTreeItem* item);
  virtual void moveContents(FXint x, FXint y);
  long onTipTimer(FXObject* sender, FXSelector sel, void* ptr);
  virtual FXTreeItem* newItem(FXTreeItem* parent, FXTreeItem* prev, FXTreeItem* next);
  virtual FXTreeItem* copyItem(FXTreeItem* src, FXTreeItem* parent, FXTreeItem* prev, FXTreeItem* next, FXTreeItem* ignore = NULL);
  virtual FXTreeItem* moveItem(FXTreeItem* src, FXTreeItem* parent, FXTreeItem* prev, FXTreeItem* next);
  FXbool isAncestor(FXTreeItem* anc, FXTreeItem* desc);
  FXbool checkAncestor(FXTreeItem* src, FXTreeItem* parent, FXTreeItem* prev, FXTreeItem* next);
  long onSelected(FXObject* sender, FXSelector sel, void* ptr);
  long onLeftBtnPress(FXObject* sender, FXSelector sel, void* ptr);
  long onLeftBtnRelease(FXObject* sender, FXSelector sel, void* ptr);
  long onEditTimer(FXObject* sender, FXSelector sel, void* ptr);
  void editItem(FXTreeItem* item);
  void editEnd();
  void editCancel();
  long onEditKeyPress(FXObject* sender, FXSelector sel, void* ptr);
  long onKeyRelease(FXObject* sender, FXSelector sel, void* ptr);
  long onEditFocusOut(FXObject* sender, FXSelector sel, void* ptr);
  
protected:
  FXTreeListEx();
  
private:
  void __init_class__();
  
protected:
  FXTreeItem* selItem;
  
private:
  FXTextField* labelEdit;
  FXTreeItem* mEditItem;
  FXTimer* editTimer;
  FXbool flgEditTimer;
  FXbool flgEnter;
};

#endif // _FXTREELISTEX_H_
